import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.LDA;
import org.shogun.RealVector;
import org.shogun.BinaryLabels;
import org.shogun.AccuracyMeasure;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.CSVFile;
import org.shogun.RealFeatures;

public class lda {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_binary_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_binary_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_binary_2d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/classifier_binary_2d_linear_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
BinaryLabels labels_train = new BinaryLabels(f_labels_train);
BinaryLabels labels_test = new BinaryLabels(f_labels_test);
//![create_features]

//![create_instance]
LDA lda = new LDA();
lda.set_features(features_train);
lda.set_labels(labels_train);
//![create_instance]

//![train_and_apply]
lda.train();
BinaryLabels labels_predict = lda.apply_binary(features_test);
//![train_and_apply]

//![extract_weights]
DoubleMatrix w = lda.get_w();
//![extract_weights]

//![evaluate_accuracy]
AccuracyMeasure eval = new AccuracyMeasure();
double accuracy = eval.evaluate(labels_predict, labels_test);
//![evaluate_accuracy]

//additional integration testing variables
DoubleMatrix output = labels_predict.get_labels();

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("lda.dat", 'w');
__sg_storage.append_wrapped_real_vector(w, "w");
__sg_storage.append_wrapped_real(accuracy, "accuracy");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.save_serializable(__sg_storage_file);

}
}
