import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.GMM;
import org.shogun.RealVector;
import org.shogun.RealMatrix;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.CSVFile;
import org.shogun.Math;
import org.shogun.RealFeatures;

public class gmm {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");

org.shogun.Math.init_random(1);

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
//![create_features]

//![create_gmm_instance]
int num_components = 3;
GMM gmm = new GMM(num_components);
//![create_gmm_instance]

//![train_sample]
gmm.set_features(features_train);
gmm.train_em();
DoubleMatrix output = gmm.sample();
//![train_sample]

//![training_smem]
gmm.train_smem();
//![training_smem]

//![extract_params]
int component_num = 1;
DoubleMatrix nth_mean = gmm.get_nth_mean(component_num);
DoubleMatrix nth_cov = gmm.get_nth_cov(component_num);
DoubleMatrix coef = gmm.get_coef();
//![extract_params]

//![cluster_output]
DoubleMatrix log_likelihoods = gmm.cluster(nth_mean);
//![cluster_output]

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("gmm.dat", 'w');
__sg_storage.append_wrapped_int(num_components, "num_components");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.append_wrapped_int(component_num, "component_num");
__sg_storage.append_wrapped_real_vector(nth_mean, "nth_mean");
__sg_storage.append_wrapped_real_matrix(nth_cov, "nth_cov");
__sg_storage.append_wrapped_real_vector(coef, "coef");
__sg_storage.append_wrapped_real_vector(log_likelihoods, "log_likelihoods");
__sg_storage.save_serializable(__sg_storage_file);

}
}
