import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.RealVector;
import org.shogun.Hierarchical;
import org.shogun.WrappedObjectArray;
import org.shogun.IntMatrix;
import org.shogun.EuclideanDistance;
import org.shogun.CSVFile;
import org.shogun.SerializableAsciiFile;
import org.shogun.RealFeatures;

public class hierarchical {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
//![create_features]

//![choose_distance]
EuclideanDistance distance = new EuclideanDistance(features_train, features_train);
//![choose_distance]

//![create_instance]
int merges = 3;
Hierarchical hierarchical = new Hierarchical(merges, distance);
//![create_instance]

//![train_model]
hierarchical.train();
//![train_model]

//![extract_results]
DoubleMatrix d = hierarchical.get_merge_distances();
DoubleMatrix cp = hierarchical.get_cluster_pairs();
//![extract_results]

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("hierarchical.dat", 'w');
__sg_storage.append_wrapped_int(merges, "merges");
__sg_storage.append_wrapped_real_vector(d, "d");
__sg_storage.save_serializable(__sg_storage_file);

}
}
