import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.BrayCurtisDistance;
import org.shogun.RealMatrix;
import org.shogun.CSVFile;
import org.shogun.SerializableAsciiFile;
import org.shogun.WrappedObjectArray;
import org.shogun.RealFeatures;

public class braycurtis {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_a = new CSVFile("../../data/fm_train_real.dat");
CSVFile f_feats_b = new CSVFile("../../data/fm_test_real.dat");

//![create_features]
RealFeatures features_a = new RealFeatures(f_feats_a);
RealFeatures features_b = new RealFeatures(f_feats_b);
//![create_features]

//![create_instance]
BrayCurtisDistance distance = new BrayCurtisDistance(features_a, features_a);
//![create_instance]

//![extract_distance]
DoubleMatrix distance_matrix_aa = distance.get_distance_matrix();
//![extract_distance]

//![refresh_distance]
distance.init(features_a, features_b);
DoubleMatrix distance_matrix_ab = distance.get_distance_matrix();
//![refresh_distance]

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("braycurtis.dat", 'w');
__sg_storage.append_wrapped_real_matrix(distance_matrix_aa, "distance_matrix_aa");
__sg_storage.append_wrapped_real_matrix(distance_matrix_ab, "distance_matrix_ab");
__sg_storage.save_serializable(__sg_storage_file);

}
}
