import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.MulticlassLabels;
import org.shogun.EProblemType;
import org.shogun.BoolVector;
import org.shogun.MulticlassAccuracy;
import org.shogun.CARTree;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.CSVFile;
import org.shogun.RealVector;
import org.shogun.Math;
import org.shogun.RealFeatures;

public class cartree {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_4class_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat");
org.shogun.Math.init_random(1);

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
MulticlassLabels labels_train = new MulticlassLabels(f_labels_train);
MulticlassLabels labels_test = new MulticlassLabels(f_labels_test);
//![create_features]

//![set_attribute_types]
BoolVector ft = new BoolVector(2);
ft.set_element(false, 0);
ft.set_element(false, 1);
//![set_attribute_types]

//![create_instance]
CARTree classifier = new CARTree(ft, EProblemType.PT_MULTICLASS, 5, true);
classifier.set_labels(labels_train);
//![create_instance]

//![train_and_apply]
classifier.train(features_train);
MulticlassLabels labels_predict = classifier.apply_multiclass(features_test);
//![train_and_apply]

//![evaluate_accuracy]
MulticlassAccuracy eval = new MulticlassAccuracy();
double accuracy = eval.evaluate(labels_predict, labels_test);
//![evaluate_accuracy]

// integration testing variables
DoubleMatrix output = labels_predict.get_labels();

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("cartree.dat", 'w');
__sg_storage.append_wrapped_real(accuracy, "accuracy");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.save_serializable(__sg_storage_file);

}
}
