import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.MulticlassLabels;
import org.shogun.RealVector;
import org.shogun.GaussianNaiveBayes;
import org.shogun.CSVFile;
import org.shogun.SerializableAsciiFile;
import org.shogun.WrappedObjectArray;
import org.shogun.RealFeatures;

public class gaussian_naive_bayes {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_4class_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
MulticlassLabels labels_train = new MulticlassLabels(f_labels_train);
//![create_features]


//![create_instance]
GaussianNaiveBayes gnb = new GaussianNaiveBayes(features_train, labels_train);
//![create_instance]

//![train_and_apply]
gnb.train();
MulticlassLabels labels_predict = gnb.apply_multiclass(features_test);
//![train_and_apply]


// integration testing variables
DoubleMatrix output = labels_predict.get_labels();

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("gaussian_naive_bayes.dat", 'w');
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.save_serializable(__sg_storage_file);

}
}
