import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.MeanSquaredError;
import org.shogun.RealVector;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.RegressionLabels;
import org.shogun.CSVFile;
import org.shogun.LinearRidgeRegression;
import org.shogun.RealFeatures;

public class linear_ridge_regression {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/regression_1d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/regression_1d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/regression_1d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/regression_1d_linear_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
RegressionLabels labels_train = new RegressionLabels(f_labels_train);
RegressionLabels labels_test = new RegressionLabels(f_labels_test);
//![create_features]

//![create_instance]
double tau = 0.001;
LinearRidgeRegression lrr = new LinearRidgeRegression(tau, features_train, labels_train);
//![create_instance]

//![train_and_apply]
lrr.train();
RegressionLabels labels_predict = lrr.apply_regression(features_test);
double bias = lrr.get_bias();
//![train_and_apply]

//[!disable_bias]
lrr.set_compute_bias(false);
//[!disable_bias]

//[!set_bias_manually]
lrr.set_bias(bias);
//[!set_bias_manually]

//[!extract_w]
DoubleMatrix weights = lrr.get_w();
//[!extract_w]

//![evaluate_error]
MeanSquaredError eval = new MeanSquaredError();
double mse = eval.evaluate(labels_predict, labels_test);
//![evaluate_error]

// integration testing variables
DoubleMatrix output = labels_test.get_labels();

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("linear_ridge_regression.dat", 'w');
__sg_storage.append_wrapped_real(tau, "tau");
__sg_storage.append_wrapped_real(bias, "bias");
__sg_storage.append_wrapped_real_vector(weights, "weights");
__sg_storage.append_wrapped_real(mse, "mse");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.save_serializable(__sg_storage_file);

}
}
