import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.MeanSquaredError;
import org.shogun.MeanRule;
import org.shogun.RealVector;
import org.shogun.RandomForest;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.RegressionLabels;
import org.shogun.CSVFile;
import org.shogun.Math;
import org.shogun.RealFeatures;

public class random_forest_regression {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/regression_1d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/regression_1d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/regression_1d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/regression_1d_linear_labels_test.dat");
org.shogun.Math.init_random(1);

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
RegressionLabels labels_train = new RegressionLabels(f_labels_train);
RegressionLabels labels_test = new RegressionLabels(f_labels_test);
//![create_features]

//![create_combination_rule]
MeanRule mean_rule = new MeanRule();
//![create_combination_rule]

//![create_instance]
RandomForest rand_forest = new RandomForest(features_train, labels_train, 5);
rand_forest.set_combination_rule(mean_rule);
//![create_instance]

//![train_and_apply]
rand_forest.train();
RegressionLabels labels_predict = rand_forest.apply_regression(features_test);
//![train_and_apply]

//![evaluate_error]
MeanSquaredError mse = new MeanSquaredError();
double oob = rand_forest.get_oob_error(mse);
double mserror = mse.evaluate(labels_predict, labels_test);
//![evaluate_error]

// additional integration testing variables
DoubleMatrix output = labels_predict.get_labels();

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("random_forest_regression.dat", 'w');
__sg_storage.append_wrapped_real(oob, "oob");
__sg_storage.append_wrapped_real(mserror, "mserror");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.save_serializable(__sg_storage_file);

}
}
